From a93e84eed0bc792be7acdab434671bea25c0b7ee Mon Sep 17 00:00:00 2001
From: Justin Pryzby <pryzbyj@telsasoft.com>
Date: Fri, 6 Dec 2019 21:38:02 -0600
Subject: [PATCH] Make "Cost" a structure..

..to allow "Explain" to show its members.

As mentioned by Jeff here:
https://www.postgresql.org/message-id/CAMkU%3D1zBJNVo2DGYBgLJqpu8fyjCE_ys%2Bmsr6pOEoiwA7y5jrA%40mail.gmail.com
---
 src/backend/commands/explain.c            |  65 +-
 src/backend/executor/nodeHashjoin.c       |   3 +-
 src/backend/executor/nodeSubplan.c        |   9 +-
 src/backend/nodes/equalfuncs.c            |   7 +-
 src/backend/nodes/outfuncs.c              |  25 +-
 src/backend/nodes/readfuncs.c             |  15 +-
 src/backend/optimizer/geqo/geqo_eval.c    |   5 +-
 src/backend/optimizer/geqo/geqo_pool.c    |  17 +-
 src/backend/optimizer/path/allpaths.c     |   2 +-
 src/backend/optimizer/path/costsize.c     | 999 ++++++++++++++++++------------
 src/backend/optimizer/path/indxpath.c     |  12 +-
 src/backend/optimizer/plan/createplan.c   |  13 +-
 src/backend/optimizer/plan/planagg.c      |   7 +-
 src/backend/optimizer/plan/planner.c      |  26 +-
 src/backend/optimizer/plan/subselect.c    |   9 +-
 src/backend/optimizer/prep/prepunion.c    |   7 +-
 src/backend/optimizer/util/appendinfo.c   |   3 +-
 src/backend/optimizer/util/clauses.c      |  14 +-
 src/backend/optimizer/util/pathnode.c     | 268 ++++----
 src/backend/optimizer/util/placeholder.c  |   4 +-
 src/backend/optimizer/util/plancat.c      |  10 +-
 src/backend/optimizer/util/relnode.c      |  12 +-
 src/backend/optimizer/util/restrictinfo.c |   3 +-
 src/backend/utils/adt/selfuncs.c          | 120 ++--
 src/backend/utils/cache/plancache.c       |   3 +-
 src/include/nodes/nodes.h                 |  16 +-
 src/include/optimizer/cost.h              |  31 +-
 src/include/utils/selfuncs.h              |   5 +-
 src/test/regress/regress.c                |   5 +-
 29 files changed, 1028 insertions(+), 687 deletions(-)

diff --git a/src/backend/commands/explain.c b/src/backend/commands/explain.c
index 62fb343..acc6ad4 100644
--- a/src/backend/commands/explain.c
+++ b/src/backend/commands/explain.c
@@ -24,6 +24,7 @@
 #include "nodes/extensible.h"
 #include "nodes/makefuncs.h"
 #include "nodes/nodeFuncs.h"
+#include "optimizer/cost.h"
 #include "parser/parsetree.h"
 #include "rewrite/rewriteHandler.h"
 #include "storage/bufmgr.h"
@@ -61,6 +62,7 @@ static void report_triggers(ResultRelInfo *rInfo, bool show_relname,
 							ExplainState *es);
 static double elapsed_time(instr_time *starttime);
 static bool ExplainPreScanNode(PlanState *planstate, Bitmapset **rels_used);
+static void explain_verbose_costs(Cost *cost, ExplainState *es);
 static void ExplainNode(PlanState *planstate, List *ancestors,
 						const char *relationship, const char *plan_name,
 						ExplainState *es);
@@ -1041,6 +1043,26 @@ ExplainPreScanNode(PlanState *planstate, Bitmapset **rels_used)
 	return planstate_tree_walker(planstate, ExplainPreScanNode, rels_used);
 }
 
+static void explain_verbose_costs(Cost *cost, ExplainState *es)
+{
+	ExplainPropertyFloat("cpu_index_tuple_cost", NULL,
+		cost->cpu_index_tuple_cost, 2, es);
+	ExplainPropertyFloat("cpu_operator_cost", NULL,
+		cost->cpu_operator_cost, 2, es);
+	ExplainPropertyFloat("cpu_tuple_cost", NULL,
+		cost->cpu_tuple_cost, 2, es);
+	ExplainPropertyFloat("parallel_setup_cost", NULL,
+		cost->parallel_setup_cost, 2, es);
+	ExplainPropertyFloat("parallel_tuple_cost", NULL,
+		cost->parallel_tuple_cost, 2, es);
+	ExplainPropertyFloat("random_page_cost", NULL,
+		cost->random_page_cost, 2, es);
+	ExplainPropertyFloat("seq_page_cost", NULL,
+		cost->seq_page_cost, 2, es);
+	ExplainPropertyFloat("disable_cost", NULL,
+		cost->disable_cost, 2, es);
+}
+
 /*
  * ExplainNode -
  *	  Appends a description of a plan tree to es->str
@@ -1473,18 +1495,47 @@ ExplainNode(PlanState *planstate, List *ancestors,
 
 	if (es->costs)
 	{
-		if (es->format == EXPLAIN_FORMAT_TEXT)
+		if (es->format == EXPLAIN_FORMAT_TEXT && !es->verbose)
 		{
 			appendStringInfo(es->str, "  (cost=%.2f..%.2f rows=%.0f width=%d)",
-							 plan->startup_cost, plan->total_cost,
+							 cost_asscalar(&plan->startup_cost),
+							 cost_asscalar(&plan->total_cost),
 							 plan->plan_rows, plan->plan_width);
-		}
-		else
-		{
-			ExplainPropertyFloat("Startup Cost", NULL, plan->startup_cost,
+		} else if (es->format == EXPLAIN_FORMAT_TEXT) { /* && es->verbose */
+			// XXX: other fields
+			appendStringInfo(es->str, "  (cost=Seq page %.2f Rand page %2f CPU tuple: %2f CPU oper %2f"\
+										"..Seq page %.2f Rand page %2f CPU tuple: %2f CPU oper %2f"\
+										" rows=%.0f width=%d)",
+							 plan->startup_cost.seq_page_cost,
+							 plan->startup_cost.random_page_cost,
+							 plan->startup_cost.cpu_tuple_cost,
+							 plan->startup_cost.cpu_operator_cost,
+							 plan->total_cost.seq_page_cost,
+							 plan->total_cost.random_page_cost,
+							 plan->total_cost.cpu_tuple_cost,
+							 plan->total_cost.cpu_operator_cost,
+							 plan->plan_rows, plan->plan_width);
+		} else if (!es->verbose) {
+			ExplainPropertyFloat("Startup Cost", NULL, cost_asscalar(&plan->startup_cost),
 								 2, es);
-			ExplainPropertyFloat("Total Cost", NULL, plan->total_cost,
+			ExplainPropertyFloat("Total Cost", NULL, cost_asscalar(&plan->total_cost),
 								 2, es);
+
+			ExplainPropertyFloat("Plan Rows", NULL, plan->plan_rows,
+								 0, es);
+			ExplainPropertyInteger("Plan Width", NULL, plan->plan_width,
+								   es);
+		}
+		else /* !EXPLAIN_FORMAT_TEXT text && es->verbose */
+		{
+			ExplainOpenGroup("Startup Cost", "Startup Cost", false, es);
+			explain_verbose_costs(&plan->startup_cost, es);
+			ExplainCloseGroup("Startup Cost", "Startup Cost", false, es);
+
+			ExplainOpenGroup("Total Cost", "Total Cost", true, es);
+			explain_verbose_costs(&plan->total_cost, es);
+			ExplainCloseGroup("Total Cost", "Total Cost", true, es);
+
 			ExplainPropertyFloat("Plan Rows", NULL, plan->plan_rows,
 								 0, es);
 			ExplainPropertyInteger("Plan Width", NULL, plan->plan_width,
diff --git a/src/backend/executor/nodeHashjoin.c b/src/backend/executor/nodeHashjoin.c
index ec37558..797ee20 100644
--- a/src/backend/executor/nodeHashjoin.c
+++ b/src/backend/executor/nodeHashjoin.c
@@ -112,6 +112,7 @@
 #include "executor/hashjoin.h"
 #include "executor/nodeHash.h"
 #include "executor/nodeHashjoin.h"
+#include "optimizer/cost.h"
 #include "miscadmin.h"
 #include "pgstat.h"
 #include "utils/memutils.h"
@@ -256,7 +257,7 @@ ExecHashJoinImpl(PlanState *pstate, bool parallel)
 					node->hj_FirstOuterTupleSlot = NULL;
 				}
 				else if (HJ_FILL_OUTER(node) ||
-						 (outerNode->plan->startup_cost < hashNode->ps.plan->total_cost &&
+						 (cost_islt(&outerNode->plan->startup_cost, &hashNode->ps.plan->total_cost) &&
 						  !node->hj_OuterNotEmpty))
 				{
 					node->hj_FirstOuterTupleSlot = ExecProcNode(outerNode);
diff --git a/src/backend/executor/nodeSubplan.c b/src/backend/executor/nodeSubplan.c
index 2c364bd..6c41582 100644
--- a/src/backend/executor/nodeSubplan.c
+++ b/src/backend/executor/nodeSubplan.c
@@ -35,6 +35,7 @@
 #include "miscadmin.h"
 #include "nodes/makefuncs.h"
 #include "nodes/nodeFuncs.h"
+#include "optimizer/cost.h"
 #include "utils/array.h"
 #include "utils/lsyscache.h"
 #include "utils/memutils.h"
@@ -1353,10 +1354,12 @@ ExecInitAlternativeSubPlan(AlternativeSubPlan *asplan, PlanState *parent)
 	subplan1 = (SubPlan *) linitial(asplan->subplans);
 	subplan2 = (SubPlan *) lsecond(asplan->subplans);
 
-	cost1 = subplan1->startup_cost + num_calls * subplan1->per_call_cost;
-	cost2 = subplan2->startup_cost + num_calls * subplan2->per_call_cost;
+	cost1 = subplan1->startup_cost;
+	cost_add_mul(&cost1, &subplan1->per_call_cost, num_calls);
+	cost2 = subplan2->startup_cost;
+	cost_add_mul(&cost2, &subplan2->per_call_cost, num_calls);
 
-	if (cost1 < cost2)
+	if (cost_islt(&cost1, &cost2))
 		asstate->active = 0;
 	else
 		asstate->active = 1;
diff --git a/src/backend/nodes/equalfuncs.c b/src/backend/nodes/equalfuncs.c
index 2fcd4a3..d262c16 100644
--- a/src/backend/nodes/equalfuncs.c
+++ b/src/backend/nodes/equalfuncs.c
@@ -32,6 +32,7 @@
 #include "miscadmin.h"
 #include "nodes/extensible.h"
 #include "nodes/pathnodes.h"
+#include "optimizer/cost.h"
 #include "utils/datum.h"
 
 
@@ -449,8 +450,10 @@ _equalSubPlan(const SubPlan *a, const SubPlan *b)
 	COMPARE_NODE_FIELD(setParam);
 	COMPARE_NODE_FIELD(parParam);
 	COMPARE_NODE_FIELD(args);
-	COMPARE_SCALAR_FIELD(startup_cost);
-	COMPARE_SCALAR_FIELD(per_call_cost);
+	if (cost_asscalar(&a->startup_cost) != cost_asscalar(&b->startup_cost))
+		return false;
+	if (cost_asscalar(&a->per_call_cost) != cost_asscalar(&b->per_call_cost))
+		return false;
 
 	return true;
 }
diff --git a/src/backend/nodes/outfuncs.c b/src/backend/nodes/outfuncs.c
index a80eccc..e605c10 100644
--- a/src/backend/nodes/outfuncs.c
+++ b/src/backend/nodes/outfuncs.c
@@ -34,6 +34,7 @@
 #include "nodes/extensible.h"
 #include "nodes/pathnodes.h"
 #include "nodes/plannodes.h"
+#include "optimizer/cost.h"
 #include "utils/datum.h"
 #include "utils/rel.h"
 
@@ -86,6 +87,10 @@ static void outChar(StringInfo str, char c);
 #define WRITE_FLOAT_FIELD(fldname,format) \
 	appendStringInfo(str, " :" CppAsString(fldname) " " format, node->fldname)
 
+/* Write a float field --- caller must give format to define precision */
+#define WRITE_COST_FIELD(fldname,format) \
+	appendStringInfo(str, " :" CppAsString(fldname) " " format, cost_asscalar(&node->fldname))
+
 /* Write a boolean field */
 #define WRITE_BOOL_FIELD(fldname) \
 	appendStringInfo(str, " :" CppAsString(fldname) " %s", \
@@ -327,8 +332,8 @@ _outPlannedStmt(StringInfo str, const PlannedStmt *node)
 static void
 _outPlanInfo(StringInfo str, const Plan *node)
 {
-	WRITE_FLOAT_FIELD(startup_cost, "%.2f");
-	WRITE_FLOAT_FIELD(total_cost, "%.2f");
+	WRITE_COST_FIELD(startup_cost, "%.2f");
+	WRITE_COST_FIELD(total_cost, "%.2f");
 	WRITE_FLOAT_FIELD(plan_rows, "%.0f");
 	WRITE_INT_FIELD(plan_width);
 	WRITE_BOOL_FIELD(parallel_aware);
@@ -1321,8 +1326,8 @@ _outSubPlan(StringInfo str, const SubPlan *node)
 	WRITE_NODE_FIELD(setParam);
 	WRITE_NODE_FIELD(parParam);
 	WRITE_NODE_FIELD(args);
-	WRITE_FLOAT_FIELD(startup_cost, "%.2f");
-	WRITE_FLOAT_FIELD(per_call_cost, "%.2f");
+	WRITE_COST_FIELD(startup_cost, "%.2f");
+	WRITE_COST_FIELD(per_call_cost, "%.2f");
 }
 
 static void
@@ -1717,8 +1722,8 @@ _outPathInfo(StringInfo str, const Path *node)
 	WRITE_BOOL_FIELD(parallel_safe);
 	WRITE_INT_FIELD(parallel_workers);
 	WRITE_FLOAT_FIELD(rows, "%.0f");
-	WRITE_FLOAT_FIELD(startup_cost, "%.2f");
-	WRITE_FLOAT_FIELD(total_cost, "%.2f");
+	WRITE_COST_FIELD(startup_cost, "%.2f");
+	WRITE_COST_FIELD(total_cost, "%.2f");
 	WRITE_NODE_FIELD(pathkeys);
 }
 
@@ -1757,7 +1762,7 @@ _outIndexPath(StringInfo str, const IndexPath *node)
 	WRITE_NODE_FIELD(indexorderbys);
 	WRITE_NODE_FIELD(indexorderbycols);
 	WRITE_ENUM_FIELD(indexscandir, ScanDirection);
-	WRITE_FLOAT_FIELD(indextotalcost, "%.2f");
+	WRITE_COST_FIELD(indextotalcost, "%.2f");
 	WRITE_FLOAT_FIELD(indexselectivity, "%.4f");
 }
 
@@ -2411,8 +2416,8 @@ _outPathTarget(StringInfo str, const PathTarget *node)
 		for (i = 0; i < list_length(node->exprs); i++)
 			appendStringInfo(str, " %u", node->sortgrouprefs[i]);
 	}
-	WRITE_FLOAT_FIELD(cost.startup, "%.2f");
-	WRITE_FLOAT_FIELD(cost.per_tuple, "%.2f");
+	WRITE_COST_FIELD(cost.startup, "%.2f");
+	WRITE_COST_FIELD(cost.per_tuple, "%.2f");
 	WRITE_INT_FIELD(width);
 }
 
@@ -2537,7 +2542,7 @@ _outMinMaxAggInfo(StringInfo str, const MinMaxAggInfo *node)
 	WRITE_NODE_FIELD(target);
 	/* We intentionally omit subroot --- too large, not interesting enough */
 	WRITE_NODE_FIELD(path);
-	WRITE_FLOAT_FIELD(pathcost, "%.2f");
+	WRITE_COST_FIELD(pathcost, "%.2f");
 	WRITE_NODE_FIELD(param);
 }
 
diff --git a/src/backend/nodes/readfuncs.c b/src/backend/nodes/readfuncs.c
index 764e3bb..701475c 100644
--- a/src/backend/nodes/readfuncs.c
+++ b/src/backend/nodes/readfuncs.c
@@ -38,6 +38,7 @@
 #include "nodes/parsenodes.h"
 #include "nodes/plannodes.h"
 #include "nodes/readfuncs.h"
+#include "optimizer/cost.h"
 #include "utils/builtins.h"
 
 
@@ -113,6 +114,12 @@
 	token = pg_strtok(&length);		/* get field value */ \
 	local_node->fldname = atof(token)
 
+/* Read a float field */
+#define READ_COST_FIELD(fldname) \
+	token = pg_strtok(&length);		/* skip :fldname */ \
+	token = pg_strtok(&length);		/* get field value */ \
+	local_node->fldname.disable_cost = atof(token) // XXX
+
 /* Read a boolean field */
 #define READ_BOOL_FIELD(fldname) \
 	token = pg_strtok(&length);		/* skip :fldname */ \
@@ -1534,8 +1541,8 @@ ReadCommonPlan(Plan *local_node)
 {
 	READ_TEMP_LOCALS();
 
-	READ_FLOAT_FIELD(startup_cost);
-	READ_FLOAT_FIELD(total_cost);
+	READ_COST_FIELD(startup_cost);
+	READ_COST_FIELD(total_cost);
 	READ_FLOAT_FIELD(plan_rows);
 	READ_INT_FIELD(plan_width);
 	READ_BOOL_FIELD(parallel_aware);
@@ -2466,8 +2473,8 @@ _readSubPlan(void)
 	READ_NODE_FIELD(setParam);
 	READ_NODE_FIELD(parParam);
 	READ_NODE_FIELD(args);
-	READ_FLOAT_FIELD(startup_cost);
-	READ_FLOAT_FIELD(per_call_cost);
+	READ_COST_FIELD(startup_cost);
+	READ_COST_FIELD(per_call_cost);
 
 	READ_DONE();
 }
diff --git a/src/backend/optimizer/geqo/geqo_eval.c b/src/backend/optimizer/geqo/geqo_eval.c
index 7b67a29..9f827ba 100644
--- a/src/backend/optimizer/geqo/geqo_eval.c
+++ b/src/backend/optimizer/geqo/geqo_eval.c
@@ -29,6 +29,7 @@
 #include "optimizer/joininfo.h"
 #include "optimizer/pathnode.h"
 #include "optimizer/paths.h"
+#include "optimizer/cost.h"
 #include "utils/memutils.h"
 
 
@@ -62,7 +63,7 @@ geqo_eval(PlannerInfo *root, Gene *tour, int num_gene)
 	Cost		fitness;
 	int			savelength;
 	struct HTAB *savehash;
-
+	extern double disable_cost;
 	/*
 	 * Create a private memory context that will hold all temp storage
 	 * allocated inside gimme_tree().
@@ -115,7 +116,7 @@ geqo_eval(PlannerInfo *root, Gene *tour, int num_gene)
 		fitness = best_path->total_cost;
 	}
 	else
-		fitness = DBL_MAX;
+		cost_set_member(&fitness, disable_cost);
 
 	/*
 	 * Restore join_rel_list to its former state, and put back original
diff --git a/src/backend/optimizer/geqo/geqo_pool.c b/src/backend/optimizer/geqo/geqo_pool.c
index f29fcc2..3ce7f8d 100644
--- a/src/backend/optimizer/geqo/geqo_pool.c
+++ b/src/backend/optimizer/geqo/geqo_pool.c
@@ -30,6 +30,7 @@
 #include "optimizer/geqo_copy.h"
 #include "optimizer/geqo_pool.h"
 #include "optimizer/geqo_recombination.h"
+#include "optimizer/cost.h"
 
 
 static int	compare(const void *arg1, const void *arg2);
@@ -108,7 +109,7 @@ random_init_pool(PlannerInfo *root, Pool *pool)
 		init_tour(root, chromo[i].string, pool->string_length);
 		pool->data[i].worth = geqo_eval(root, chromo[i].string,
 										pool->string_length);
-		if (pool->data[i].worth < DBL_MAX)
+		if (cost_asscalar(&pool->data[i].worth) < disable_cost)
 			i++;
 		else
 		{
@@ -147,9 +148,9 @@ compare(const void *arg1, const void *arg2)
 	const Chromosome *chromo1 = (const Chromosome *) arg1;
 	const Chromosome *chromo2 = (const Chromosome *) arg2;
 
-	if (chromo1->worth == chromo2->worth)
+	if (cost_asscalar(&chromo1->worth) == cost_asscalar(&chromo2->worth))
 		return 0;
-	else if (chromo1->worth > chromo2->worth)
+	else if (cost_isgt(&chromo1->worth, &chromo2->worth))
 		return 1;
 	else
 		return -1;
@@ -195,7 +196,7 @@ spread_chromo(PlannerInfo *root, Chromosome *chromo, Pool *pool)
 				tmp_chromo;
 
 	/* new chromo is so bad we can't use it */
-	if (chromo->worth > pool->data[pool->size - 1].worth)
+	if (cost_isgt(&chromo->worth, &pool->data[pool->size - 1].worth))
 		return;
 
 	/* do a binary search to find the index of the new chromo */
@@ -209,11 +210,11 @@ spread_chromo(PlannerInfo *root, Chromosome *chromo, Pool *pool)
 	{
 		/* these 4 cases find a new location */
 
-		if (chromo->worth <= pool->data[top].worth)
+		if (!cost_isgt(&chromo->worth, &pool->data[top].worth))
 			index = top;
-		else if (chromo->worth == pool->data[mid].worth)
+		else if (cost_asscalar(&chromo->worth) == cost_asscalar(&pool->data[mid].worth))
 			index = mid;
-		else if (chromo->worth == pool->data[bot].worth)
+		else if (cost_asscalar(&chromo->worth) == cost_asscalar(&pool->data[bot].worth))
 			index = bot;
 		else if (bot - top <= 1)
 			index = bot;
@@ -224,7 +225,7 @@ spread_chromo(PlannerInfo *root, Chromosome *chromo, Pool *pool)
 		 * yet been found.
 		 */
 
-		else if (chromo->worth < pool->data[mid].worth)
+		else if (cost_islt(&chromo->worth, &pool->data[mid].worth))
 		{
 			bot = mid;
 			mid = top + ((bot - top) / 2);
diff --git a/src/backend/optimizer/path/allpaths.c b/src/backend/optimizer/path/allpaths.c
index db3a68a..d227eef 100644
--- a/src/backend/optimizer/path/allpaths.c
+++ b/src/backend/optimizer/path/allpaths.c
@@ -1419,7 +1419,7 @@ add_paths_to_append_rel(PlannerInfo *root, RelOptInfo *rel,
 			}
 			else if (nppath == NULL ||
 					 (cheapest_partial_path != NULL &&
-					  cheapest_partial_path->total_cost < nppath->total_cost))
+					  cost_islt(&cheapest_partial_path->total_cost, &nppath->total_cost)))
 			{
 				/* Partial path is cheaper or the only option. */
 				Assert(cheapest_partial_path != NULL);
